				var marge = {top: 60, bottom: 60, left: 60, right: 60}
        var svg = d3.select("svg")
        var width = svg.attr("width")
        var height = svg.attr("height")
        var g = svg .append("g")
                    .attr("transform", "translate("+marge.top+","+marge.left+")");   //group

    d3.json("graphic.json", function(error, graph){
      	if (error) throw error;
      
        var nodes = graph.nodes;

        var edges = graph.links;
            
        //set color
        var colorscale = d3.scaleOrdinal().domain(d3.range(nodes.length)).range(d3.schemeCategory10);

        //generate a force graphic
        var forceSimulation = d3.forceSimulation()
                                .force("link", d3.forceLink())
                                .force("charge", d3.forceManyBody())
                                .force("center", d3.forceCenter());

        //init graphic
        //generate node data
        forceSimulation.nodes(nodes).on("tick",ticked);
        //generate edge data
        forceSimulation.force("link")
                       .links(edges)
                       .distance(function(d){
                            return 100;
        })

        forceSimulation.force("center")
                       .x(width/2)
                       .y(height/2);

        //draw edge
        //
        var links = g.append("g")
                     .selectAll("line")
                     .data(edges)
                     .enter()
                     .append("line")
                     .attr("stroke", function(d,i){
                            return colorscale(i);
        }).attr("stroke-width",function(d){
                       return d.value;
                     })
                    .enter().append("svg:marker")    // This section adds in the arrows
                      .attr("id", String)
                      .attr("viewBox", "0 -5 10 10")
                      .attr("refX", 15)
                      .attr("refY", -1.5)
                      .attr("markerWidth", 6)
                      .attr("markerHeight", 6)
                      .attr("orient", "auto");

        var linksText = g.append("g")
                         .selectAll("text")
                         .data(edges)
                         .enter()
                         .append("text")
                         .text(function(d){
                                return null;
        })

        //group
        var gs = g.selectAll(".circleText")
                  .data(nodes)
                  .enter()
                  .append("g")
                  .attr("transform",function(d,i){
                        var cirX = d.x;
                        var cirY = d.y;
                        return "translate("+cirX+","+cirY+")";
                  })
                  .call(d3.drag()
                  .on("start",started)
                  .on("drag",dragged)
                  .on("end", ended));
        
        //draw node
        gs.append("circle")
    	  .attr("r",function(d){
            return 5;
        })
   		  .attr("fill",function(d,i){
    			return colorscale(i);
    		})

        //charactor
        gs.append("text")
          .attr("x", -10)
          .attr("y", -20)
          .attr("dy", 10)
          .text(function(d){
              return d.name;
          })


        //functions implement
        function ticked(){
            links.attr("x1", function(d){return d.source.x;})
                 .attr("y1", function(d){return d.source.y;})
                 .attr("x2", function(d){return d.target.x;})
                 .attr("y2", function(d){return d.target.y;})
            linksText.attr("x",function(d){
                return (d.source.x+d.target.x)/2;
            })
            .attr("y",function(d){
                return (d.source.y+d.target.y)/2;
            });
            gs.attr("transform", function(d){return "translate("+d.x+","+d.y+")";});
        }

        function started(d){
            if(!d3.event.active){
                    forceSimulation.alphaTarget(0.8).restart();
            }
                d.fx = d.x;
                d.fy = d.y;
        }

        function dragged(d){
            d.fx = d3.event.x;
            d.fy = d3.event.y;
        }

        function ended(d){
            if(!d3.event.active){
                forceSimulation.alphaTarget(0);
            }
            d.fx = null;
            d.fy = null;
        }
      

    });